#!/bin/sh
NODE_ROOT='/usr/NX'

COMMAND_ECHO="/bin/echo"
COMMAND_CAT="/bin/cat"
COMMAND_SU="/bin/su"
COMMAND_RM="/bin/rm"
COMMAND_CHOWN="/bin/chown"

if [ $# -ne 6 ];
  then
    $COMMAND_ECHO "NX> 599 Error: Wrong parameters count." && exit 1
fi

COMMAND_XDPYINFO="$3"
USERNAME="$4"
DISPLAY="$5"
GLOBALXAUTHORITY="$6"

if [ "x$1" != "xnx" ];
  then
    $COMMAND_ECHO "NX> 599 Error: nxdpyinfo.sh only 'nx' user can use xdpyinfo by this script" 1>&2
    exit 1
fi

if [ "x$COMMAND_XDPYINFO" = "x" ];
then
 $COMMAND_ECHO "NX> 599 Error: nxdpyinfo.sh missing command xdpyinfo parameter" 1>&2
 exit 1
fi

checkPpid() {

  if [ "x$1" = "x" ];
  then
    $COMMAND_ECHO "Missing pid"
    return 1
  fi
  if [ ! -e /proc/$1/cmdline ];
  then
    $COMMAND_ECHO "Wrong pid: $1"
    return 1
  fi

  command=$($COMMAND_CAT /proc/$1/cmdline)

  $COMMAND_ECHO "$command"
}

command=$(checkPpid $2)

if [ $? != 0 ];
then
  $COMMAND_ECHO "NX> 500 Error: $command"
  exit 1
fi

if [ "$command" != "nxserver-c$NODE_ROOT/bin/nxserver --login" ];
then
  $COMMAND_ECHO "NX> 500 Error: Only the nxserver can run this script: $command.\n";
  exit 1
fi

if [ ! -x $COMMAND_XDPYINFO ];
then
  $COMMAND_ECHO "NX> 500 Error: Command: $COMMAND_XHOST doesnt exist."
  exit 1
fi

if [ "x$GLOBALXAUTHORITY" != "x" ];
then
  XAUTHORITY=$GLOBALXAUTHORITY $COMMAND_XDPYINFO -display :$DISPLAY
else
  $COMMAND_SU - $USERNAME -c "$COMMAND_XDPYINFO -display :$DISPLAY"
fi
